
package com.jeans.trayicon;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class SwingTrayPopup extends JPopupMenu {

    WindowsTrayIcon m_Icon;
    ActivateListener m_Listener;

	public SwingTrayPopup() {
	}
	
	public void setTrayIcon(WindowsTrayIcon icon) {
        if (icon != null) {
            m_Icon = icon;            
            m_Listener = new ActivateListener();
            m_Icon.addActionListener(m_Listener);
        } else {
            if (m_Icon != null) {
                m_Icon.removeActionListener(m_Listener);
                m_Icon = null;
            }
        }            
    }
    	
	public void showMenu(Point pt) {
        TrayDummyComponent frame = new TrayDummyComponent();

        // This should show the menu at a better location :-)
        //  * Thanks to Danny <danny@isfantastisch.nl> for the 
        //    setAlwaysOnTop and updateUI() hint
        
        WindowsTrayIcon.setMouseClickHook(new ClickListener());
        WindowsTrayIcon.setAlwaysOnTop(frame, true);
        Dimension d = getPreferredSize();
        show(frame, pt.x-d.width, pt.y-d.height);
        updateUI();        
	}		

	// Callback listener handles icon events
	private class ClickListener extends MouseAdapter {

	}
	
	// Callback listener handles icon events
	private class ActivateListener implements ActionListener {

		public void actionPerformed(ActionEvent evt) {
		    if (evt.getActionCommand().equals("Right")) {
				showMenu(WindowsTrayIcon.getMousePos());
			}
		}
	}
}
